#!/usr/bin/env python

##system-logviewer
##
## Copyright (C) 2001-2004 Red Hat, Inc.
## Copyright (C) 2001-2004 Tammy Fox <tfox@redhat.com>

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#Originally Written by Tammy Fox
#Last Modified May 1, 2003

## Coding conventions
## function names have underscores (_)
## variable names are semiStudlyCapped
## class names are StudlyCapped
## class instances are semiStudlyCapped

from gtk import *
import gtk
import os

class LogBuffer(gtk.TextBuffer):
    def __init__(self):
        self.buffer = gtk.TextBuffer(None)
        gtk.TextBuffer.__init__(self, None)

        baseSize = 10
        baseFont = 'sans'
        self.bodyTag = self.create_tag('body')
        self.bodyTag.set_property('font', '%s %d' % (baseFont, baseSize))
        self.bodyTag.set_property('pixels-above-lines', 1)
        self.bodyTag.set_property('pixels-below-lines', 1)
        self.end_mark = self.create_mark(None,self.get_start_iter(),True)

    def set_buffer_text(self, text):
        self.set_text(text)
        self.apply_tags()

    def clear_buffer(self):
        self.remove_all_tags(self.get_start_iter(),self.get_end_iter())

    def get_buffer(self):
        self.apply_tags()
        return self

    def size(self):
        return self.get_line_count()

    def insert_into_buffer_at_offset(self, iter, line):

       try:
           self.insert(iter, line)
       except:
           return 0

        #return 1 if all goes well
       return 1

    def apply_tags(self):
        start = self.get_iter_at_offset (0)
        end = self.get_end_iter()
        self.apply_tag(self.bodyTag, start, end)

    def get_end_mark(self):
        self.move_mark(self.end_mark,self.get_end_iter())
        return self.end_mark
